//
//  file : mux_2dir_reg.v
//


//  mux_2dir_reg mx2rg #(WIDTH, init) (.O(), .I0(), .I1(), .S(), .CLK(), .RST()) ;

module mux_2dir_reg (O, I0, I1, S, CLK, RST) ;

    parameter WIDTH = 1;
    parameter init  = 0;

    output [WIDTH-1:0] O;
    input [WIDTH-1:0]  I0, I1;
    input              S, CLK, RST;
    

    reg [WIDTH-1:0]    mux, O;

    always @(posedge CLK or posedge RST)
      if (RST)  O <= init;
      else      O <= mux;

    always @(I0, I1, S)
      case (S)
        1'b0: mux = I0;
        1'b1: mux = I1;
      endcase // case(S)
    
endmodule // mux_2dir_reg
