//
//  file : mux_4dir_reg.v
//

//  mux_4dir_reg mx4rg #(WIDTH,INIT) (.O(), .I0(), .I1(), .I2(), .I3(), .S(), .CLK(), .RST()) ;

module mux_4dir_reg (O, I0, I1, I2, I3, S, CLK, RST) ;

    parameter WIDTH = 1;
    parameter INIT  = 0;

    output [WIDTH-1:0] O;
    input [WIDTH-1:0]  I0, I1, I2, I3;
    input              CLK, RST;
    input [1:0]        S;

    reg [WIDTH-1:0]    mux, O;

    always @(posedge CLK or posedge RST)
      if (RST)     O <= INIT;
      else         O <= mux;

    always @(I0, I1, I2, I3, S)
      case (S)
        2'b00: mux = I0;
        2'b01: mux = I1;
        2'b10: mux = I2;
        2'b11: mux = I3;
      endcase // case(S)
    
endmodule // mux_4dir_reg
