//
// file : reg_1stg.v
//
// 1 stage register with parameterized width 
// and init values for both stages
//
//  WIDTH = 1.. - synthesized on V-II grade -5 at 850 MHz (TODO)
//


// reg_1stg #(WIDTH,init0) reg1stg
//        (.O1(), .I(), .CLK(), .RST() ) ;



module reg_1stg (O1, I, CLK, RST ) ;

    parameter WIDTH      = 1;
    parameter stg_0_init = 0;

    input  [WIDTH-1:0] I;

    output [WIDTH-1:0] O1;
    
    input              CLK, RST;


    reg [WIDTH-1:0]    stg_0;    
    assign             O1 = stg_0;
    
    always @(posedge CLK or posedge RST)
      if (RST) begin
          stg_0 <= stg_0_init;
      end
      else begin
          stg_0 <= I;
      end
    
endmodule
